"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_imports_1 = require("./rxjs-imports");
exports.jsonContentTypes = [
    "application/json",
    "application/vnd.api+json"
];
exports.apiRequest = function (url, options) {
    if (options === void 0) { options = {}; }
    return rxjs_imports_1.Observable.ajax(tslib_1.__assign({ url: url }, options, { responseType: "json" })).map(function (res) {
        if (res.status >= 200 && res.status < 300) {
            if (res.status === 204) {
                return res;
            }
            var header_1 = res.xhr.getResponseHeader("Content-Type");
            if (typeof header_1 === "string" &&
                exports.jsonContentTypes.some(function (contentType) { return header_1.indexOf(contentType) > -1; })) {
                return res.response;
            }
        }
        return res;
    });
};
exports.hasOwnProperties = function (obj, propertyTree) {
    if (obj instanceof Object === false) {
        return false;
    }
    var property = propertyTree[0];
    var hasProperty = obj.hasOwnProperty(property);
    if (hasProperty) {
        if (propertyTree.length === 1) {
            return hasProperty;
        }
        return exports.hasOwnProperties(obj[property], propertyTree.slice(1));
    }
    return false;
};
//# sourceMappingURL=utils.js.map